#include "md.h"
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <stdarg.h>
#include <string.h>
#include <math.h>

int *qsize;
unsigned getbits(unsigned x, int p, int n){
	return (x >> (p+1-n)) & ~(~0 << n);
}


int querySize(unsigned char *q, va_list args){
	//Assumes all numbers are pairs.
	//FIXME: Some error checking
	double result = 0;
	char *vstring;
	while (*q != '\0'){
		if((*q >= '0' && *q <= '9') || (*q >= 'a' && *q <= 'f')){
			result += 0.5;
		}
		else if(*q == '%'){
			q++;
			switch(*q){
				case 'b':
					va_arg(args, int);
					result += 1;
					break;
				case 'w':
					va_arg(args, int);
					result += 2;
					break;
				case 'd':
					result += 4;
					break;
				case 'q':
					result += 8;
					break;
				case 's': case 'x':
					//Could not declare variable here - why not?
					//error: a label can only be part of a statement and a declaration is not a statement
					vstring = va_arg(args, char*);
					result += strlen(vstring) + 2; //+2 bytes for string size
					if(*q == 's'){
						result += 1; //Zero terminated string need one extra byte for '\0'
					}
					break;
			}
		}
		q++;
	}
	DBG("Float size of query: %f\n", result);
	return (int) result;
}


unsigned char* formatQuery(int *qsize, unsigned char *c, ...){

	DBG("%s\n", "Enter");
	va_list arguments;
	va_list acopy;
	va_start(arguments, c);
	va_copy(acopy, arguments);

	int sizeOfQuery = querySize(c, acopy);
	*qsize = sizeOfQuery + 1; //add one for the statusControl byte	

	unsigned char *buffer;
	buffer = NULL;
	//Add one for control message
	buffer = (unsigned char *) malloc(sizeOfQuery * sizeof(char) + sizeof(char) + 1);
	buffer[0] = '\0'; //This is a STATUS_CONTROL message
	int i = 0;
	int half = 0;
	unsigned char tmp;
	unsigned char tmp2;
	int j = 1;
	int vint;
	int len;
	char *vstring;	
	int escaped = 0;
	while(c[i] != '\0'){
		if(escaped){
			escaped = 0;
			switch(c[i]){
				case 'b':
					vint = va_arg(arguments, int);
					buffer[j++] = (unsigned char) getbits(vint, 7, 8); 
					DBG("Byte argument is: %x result is: %02x\n", vint, buffer[j-1]);
					break;
				case 'w':
					vint = va_arg(arguments, int);
					buffer[j++] = (unsigned char) getbits(vint, 15, 8);
					buffer[j++] = (unsigned char) getbits(vint, 7, 8);
					DBG("Word argument is: %x result is a: %02x, b: %02x\n", vint,  buffer[j-2], buffer[j-1]);
					break;
				case 'd':
					break;
				case 'q':
					break;
				case 's': case 'x':
					vstring = va_arg(arguments, char*);
					len = strlen(vstring);
					buffer[j++] = (char) (len >> 8) & 0xff; //j++;
					buffer[j++] = (char) len & 0xff; //j++;
					while(*vstring != '\0'){
						buffer[j++] = *vstring++;
					}
					if (c[i] == 's'){
						buffer[j++] = '\0';
					}
					break;
				default:
					break;
			}
			i++;
			continue;
		}
		else if( ((c[i] >= '0') && (c[i] <= '9')) || 
						 ((c[i] >= 'a') && (c[i] <= 'f'))){
			if( (c[i] >= '0') && (c[i] <= '9') ) tmp = c[i] - '0'; //c[i] = c[i] - '0';
			if( (c[i] >= 'a') && (c[i] <= 'f') ) tmp = c[i] - 'W'; //c[i] = c[i] - 'W';	
			if(!half){
				tmp2 = tmp; half = 1; //c[i]; half = 1;
			}else{
				buffer[j++] = (tmp2 << 4) | tmp; //c[i];
				tmp &= 0; half = 0;
			}
			i++;
			continue;
		}
		else if((c[i] == '%')){
			escaped = 1;
			i++;
			continue;
		}
		else{
			i++;
		}
	}
	DBG("%s\n", "Leaving formatQuery");
	return buffer;
}

//Size of aquired result
//Pointer to extracted variables - removed
//Query to parse
//Format of query
unsigned char* scanQuery(int qsize, unsigned char *c, unsigned char *f){
	DBG("%s\n", "Enter");

	unsigned char *result = malloc(qsize * sizeof(char));
	int zz = 0;
	for(zz = 0; zz < qsize; zz++){
		result[zz] = 0;
	}
	DBG("qsize is %d\n", qsize);

	int i = 0; //format counter
	unsigned char tmp;
	unsigned int sl;
	int j = 0; //query to parse counter
	int k = 0; //result counter
	int escaped = 0;

	while(f[i] != '\0'){
		if(escaped){
			escaped = 0;
			switch(f[i]){
				case '?':
					i++; j++;
					break;
				case 'b':
					result[k] = c[j];
					j++; i++; k++; 
					break;
				case 'w':
					result[k] = c[j]; j++; k++;
					result[k] = c[j]; j++; k++; i++;
					break;
				case 'd':
					break;
				case 'q':
					break;
				case 's': case 'x':
					sl = 0;
					sl = (unsigned int) c[j++]; sl = sl << 8; //Check this
					sl |= c[j++];
					while(sl-- > 0){
						result[k] = c[j]; j++; k++;
					}
					if (f[i] == 's'){
						j++;
					}
					i++;
					break;
				case '*':
					//DBG("qsize is: %i j is %i\n", qsize, j);
					while(j < qsize){
						//DBG("Starring, j is: %i value: %x\n", j, c[j]);
						result[k++] = c[j++];
					}
					break;
				default:
					break;
			}
			//i++;
			continue;
		}
		else if( ((f[i] >= '0') && (f[i] <= '9')) || 
						 ((f[i] >= 'a') && (f[i] <= 'f'))){
			//FIXME: Use temp var to avoid changing f, string constant may
			//then be used as parameters instead of arrays 
			if( (f[i] >= '0') && (f[i] <= '9') ) f[i] = f[i] - '0';
			if( (f[i] >= 'a') && (f[i] <= 'f') ) f[i] = f[i] - 'W';	
			if( (f[i+1] >= '0') && (f[i+1] <= '9') ) f[i+1] = f[i+1] - '0';
			if( (f[i+1] >= 'a') && (f[i+1] <= 'f') ) f[i+1] = f[i+1] - 'W';	
			
				tmp = f[i++];
				//FIXME: Proper error handling
				//printf("Reusult: %02x, format: %02x\n",  c[j], ((tmp << 4) | f[i]));
				if(c[j++] != ((tmp << 4) | f[i++])){
					printf("Input mismatch\n");
					exit(1);
				}
			continue;
		}
		else if((f[i] == '%')){
			escaped = 1;
			i++; 
			continue;
		}
		else{
			i++;
		}
	}
	
	DBG("%s\n", "Leaving");

	return result;
}


int mdInit(){
	if(mdusb_init()){
		printf("Could not initialise MD-device");
		return 1;
	}
	return 0;
}

int mdClose(){
	mdusb_close();
	return 0;
}

int dumpResultToFile(unsigned char *result, int rsize){

  FILE *fp;
  if ((fp = fopen ("filename","w")) == NULL){
    printf ("File could not be opened\n");
		return 1;
  }
  int i = 0;
  for(i = 0; i < rsize; i++){
    fprintf(fp, "%x", result[i]);
  }
	  
  fclose(fp);
	return 0;
}

static void dumpResult(unsigned char *result, int rsize){
  int i = 0;
  for(i = 0; i < rsize; i++){
    fprintf(stderr, "%02x ", result[i]);
  }
  fprintf(stderr, "\n");
}

unsigned char getDiscFlags(){

	int qsize = 0; //Size of formatted query
  unsigned char *query; //The formatted query
  int rsize = 0; //Size of the reply from the md
  unsigned char *reply; //The reply from the md
  unsigned char *result; //Scanned result - ready for consumption

  unsigned char qq[] = "1806 01101000 ff00 0001000b";//getDiscFlags
  unsigned char qq2[] = "1806 01101000 1000 0001000b %b";

  query = formatQuery(&qsize, qq);
  reply = sendCommand(query, qsize, &rsize);
  result = scanQuery(rsize, reply, qq2);

	DBG("%s ", "Result:");
	//dumpResult(result, rsize);
	free(reply);
	
	return result[0];
}

int getTrackCount(){

	int qsize = 0; //Size of formatted query
  unsigned char *query; //The formatted query
  int rsize = 0; //Size of the reply from the md
  unsigned char *reply; //The reply from the md
  unsigned char *result; //Scanned result - ready for consumption

  unsigned char qq[] = "1806 02101001 3000 1000 ff00 00000000"; //getTrackCount
  unsigned char qq2[] = "1806 02101001 %?%? %?%? 1000 00%?0000 %x";

  query = formatQuery(&qsize, qq);
  reply = sendCommand(query, qsize, &rsize);
  result = scanQuery(rsize, reply, qq2);

	//dumpResult(result, rsize);
	free(reply);
	
	return (int) result[5];
}


unsigned char *getDiscTitle(int wchar){
	
	int qsize = 0; //Size of formatted query
  unsigned char *query; //The formatted query
  int rsize = 0; //Size of the reply from the md
  unsigned char *reply; //The reply from the md
  unsigned char *result; //Scanned result - ready for consumption
	unsigned char qq[] = "1806 02201801 00%b 3000 0a00 ff00 %w%w";
	unsigned char qq2[] = "1806 02201801 00%? 3000 0a00 1000 %w0000 %?%?000a %w %*";
	unsigned char qq3[] = "1806 02201801 00%? 3000 0a00 1000 %w%?%? %*";


	if (wchar != 0 || wchar != 1) wchar = 0;

	int done = 0;
	int remaining = 0;
	int chunk_size = 0;
	int total = 1;
	int i = 0;
	unsigned char *title;
	int ti = 0;

	while (done < total){
  	query = formatQuery(&qsize, qq, wchar, remaining, done);

		int z = 0;
	  reply = sendCommand(query, qsize, &rsize);
		if(remaining == 0){
			DBG("%s\n", "Remaining ist zero."); 
		  result = scanQuery(rsize, reply, qq2);
			title =  (unsigned char *) malloc(rsize * sizeof(char));
			z = 0;
			for(z = 0; z < rsize; z++){
				title[z] = 0;
			}

			chunk_size = (result[0]) << 8 | result[1]; //i += 2;
			DBG("%s %i\n", "Chunk size remaining == 0 is:", chunk_size);
			chunk_size -= 6;

			total = (result[2]) << 8 | result[3]; //i += 2;
			DBG("Total size is: %i\n", total);

			title[ti++] = result[2];
			title[ti++] = result[3];
			i = 4;
			while(i < rsize){
				title[ti++] = result[i++];
				DBG("Actual title string no: %i is: %x\n", i-1, result[i-1]);
			}	
		}else{
			DBG("%s\n", "Enter remaining ist NOT zero"); 
	  	result = scanQuery(rsize, reply, qq3);
			chunk_size = 0;	
			chunk_size = (result[0]) << 8 | result[1];
			DBG("Chunk size remaining NOT 0 is: %i\n", chunk_size);
			i = 2;
			while(i < chunk_size + 2){ //FIXME: Not correct
				title[ti++] = result[i++];
			}
		}
		done += chunk_size;
		DBG("done is %i\n", done);
		remaining = total - done;
		DBG("Remaining is %i\n", remaining);
	}
	free(reply);
	free(result);
	return title;
}

unsigned char *getTrackTitle(int track, int wchar){
	//Tracks start at 0, i.e for first track, ask for 0	
	int qsize = 0; //Size of formatted query
  unsigned char *query; //The formatted query
  int rsize = 0; //Size of the reply from the md
  unsigned char *reply; //The reply from the md
  unsigned char *result; //Scanned result - ready for consumption
	unsigned char qq[] = "1806 022018%b %w 3000 0a00 ff00 00000000";
	unsigned char qq2[] = "1806 022018%? %?%? %?%? %?%? 1000 00%?0000 00%?000a %x"; 

	if (wchar != 2 || wchar != 3) wchar = 2;

  query = formatQuery(&qsize, qq, wchar, track);
  reply = sendCommand(query, qsize, &rsize);
  result = scanQuery(rsize, reply, qq2);

	//dumpResult(result, rsize);
	free(reply);

	return result;
}

unsigned char *_getTrackInfo(int track, int p1, int p2, int *rrsize){
	int qsize = 0; //Size of formatted query
  unsigned char *query; //The formatted query
  int rsize = 0; //Size of the reply from the md
  unsigned char *reply; //The reply from the md
  unsigned char *result; //Scanned result - ready for consumption
	unsigned char qq[] = "1806 02201001 %w %w %w ff00 00000000";
	unsigned char qq2[] = "1806 02201001 %?%? %?%? %?%? 1000 00%?0000 %x";

  query = formatQuery(&qsize, qq, track, p1, p2);
  reply = sendCommand(query, qsize, &rsize);
  result = scanQuery(rsize, reply, qq2);
	*rrsize = rsize;
	//dumpResultToFile(result, rsize);

	free(reply);
	return result;

}

//%x methods: _getTrackInfo, getTrackTitle, getTrackCount

int *getTrackLength(int track){
  unsigned char *result;
	unsigned char qq2[] = "0001 0006 0000 %b %b %b %b";

	int rrsize = 0; //Size of reply from _getTrackInfo()

	unsigned char *raw_value;
	raw_value = _getTrackInfo(track, 0x3000, 0x0100, &rrsize);

  result = scanQuery(rrsize, raw_value, qq2);
	//dumpResult(result, rrsize);
	
	int *track_length = malloc(4 * sizeof(int));
	
	track_length[0] = BCD2int(result[0]);
	track_length[1] = BCD2int(result[1]);
	track_length[2] = BCD2int(result[2]);
	track_length[3] = BCD2int(result[3]);

	free(result);
	return track_length;
}

	int BCD2int(unsigned char bcd){
		DBG("Input to bcd: %x\n", bcd);

		int value = 0;
		int nibble = 0;
		int nibble_value = 0;
		while(bcd){
			nibble_value = bcd & 0xf;
			DBG("nibble_value: %x\n", nibble_value);
			bcd = bcd >> 4;
			value += nibble_value * pow(10, nibble);
			nibble += 1;
		}
		return value;
	}

unsigned char *getTrackEncoding(int track){
		
  unsigned char *result;
	unsigned char qq2[] = "8007 0004 0110 %b %b";

	int rrsize = 0; //Size of reply from _getTrackInfo()

	unsigned char *raw_value;
	raw_value = _getTrackInfo(track, 0x3080, 0x0700, &rrsize);

  result = scanQuery(rrsize, raw_value, qq2);
	//dumpResult(result, rrsize);

	free(raw_value);
	return result;
}

unsigned char *getTrackFlags(int track){
	int qsize = 0; //Size of formatted query
  unsigned char *query; //The formatted query
  int rsize = 0; //Size of the reply from the md
  unsigned char *reply; //The reply from the md
  unsigned char *result; //Scanned result - ready for consumption
	unsigned char qq[] = "1806 01201001 %w ff00 00010008";
	unsigned char qq2[] = "1806 01201001 %?%? 10 00 00010008 %b";

  query = formatQuery(&qsize, qq, track);
  reply = sendCommand(query, qsize, &rsize);
  result = scanQuery(rsize, reply, qq2);
	//dumpResult(result, rsize);
	free(reply);
	return result;

	}

Groupnode *makeTGlist(){

	DBG("%s\n", "Enter makeTGlist()");

	Groupnode *root;
	root = NULL;
	
	Groupnode *g;
	int i = 0;;

	int isGrouped = 0;
	int hasTitle = 0;

	//Get disc title and groups, if any.
	unsigned char *title;
	title = getDiscTitle(0);
	
	//Extract title length from the first two bytes of the reply
	unsigned int length;
	length = title[0]; length = length << 8; length = length | title[1];
	i = 2;
	DBG("Title length is: %d\n", length); 

	if(title[length] == '/' && title[length+1] == '/')
		isGrouped = 1;
	if(title[2] == '0' && title[3] == ';')
		hasTitle = 1;

	//Keep track of processed tracks
	int *tracks;
	int nosT = getTrackCount();
	tracks = (int *) malloc(sizeof(int) * nosT);
	//tracks = (int *) malloc(sizeof(int) * getTrackCount());
	int ii = 0;
	for(ii = 0; ii < nosT; ii++){
		tracks[ii] = 0;
		DBG("TRACK %d is: %d\n", ii, tracks[ii]);
	}
 
	//Temporary storage for group names etc.
	char tmp[10240]; //FIXME: Change 2048 to lenght of title
	char *tmpstr;

	//FIXME: Add code for discs with no title
//	if(title[2] == '0' && title[3] == ';'){
	if(hasTitle){
		i = 4;
		while(!(title[i] == '/' && title[i+1] == '/')){
			i++;
		}
		if(isGrouped){
			i++; i++; //Jump past //
		}
	}
	//FIXME: Check assumptions that grouped disk without title starts with number;	
	//Is this a grouped disk?

	if(isGrouped){
		DBG("%s\n", "Grouped disk");
		//DBG("length-1 is: %x\n", title[length ]);
		//DBG("length-2 is: %x\n", title[length + 1]);

		int track_min = 0;
		int track_max = 0;
		//Loop through the groups on the disc
		int range = 0; //Does a group consist of more than one track?
		int j = 0;
		while(i < length){
			DBG("i: %d of title is now: %02x\n", i, title[i]);
			//Get the tracks that are part of the group
			//Group is empty
			if(title[i] == ';'){
				track_min = track_max = 0;
				i++;
			}else{ //Group is not empty
				while(title[i] != ';'){
					DBG("i: %d of title is now: %02x\n", i, title[i]);
					if(title[i] == '-'){
						i++;
						tmp[j] = '\0';
						track_min = atoi(tmp);
						DBG("track_min is now: %d\n", track_min);
						range = 1;
						j = 0;
					}
					tmp[j++] = (char) title[i++];
						DBG("tmp is now: %02x\n", tmp[j-1]);
				}

				tmp[j] = '\0';
				if(range){
					track_max = atoi(tmp);
					DBG("track_max is now: %d\n", track_min);
				}else{
					track_min = atoi(tmp);
					DBG("track_min is now: %d\n", track_min);
				}
				range = 0; j = 0; i++; //Dispense of the ;
			}

			//Get the name of the group. Assumption: Name has at least one character	
			int size = 0;
			while(!(title[i] == '/' && title[i+1] == '/') && (i < length)){
				tmp[j++] = (char) title[i++]; size++;
			}
			tmp[j] = '\0';
			j = 0;
			tmpstr = malloc(sizeof(char) * size + 1);
			sprintf(tmpstr, "%s", tmp);
			DBG("tmpstr is now: %s\n", tmpstr);

			int nos_tracks = 0;
			if(track_min != 0){
				if(track_max == 0){
					nos_tracks = 1;
				}else{
					nos_tracks = abs(track_min - track_max) + 1;
				}

				//Keep track of which tracks have been processed.
				//In the end, tracks that have not been processed does not belong to a group
				int cnt = 0;
				if(track_max == 0){
			 		tracks[track_min - 1] = 1;
				}else{
					cnt = track_min;
					while(cnt <= track_max){
						tracks[cnt - 1] = 1;
						cnt++;
					}
				}
			}

			g = (Groupnode *) malloc(sizeof(Groupnode));
			g->next_group = NULL;
			g->name = tmpstr;
			g->nos_tracks = nos_tracks;
			g->tlist = makeTrackList(track_min, track_max);
			g->next_group = NULL;
			addGroup(&root, g);
			i++; i++; //Move i past // to the next group
			track_min = track_max = 0;
		}
	}
	
	g = (Groupnode *) malloc(sizeof(Groupnode));
	g->next_group = NULL;
	g->name = "Tracks that does not belong to any group";
	int freetrks = 0;
	for(ii = 0; ii < nosT; ii++){
		if(tracks[ii] == 0) freetrks++;
	} 
	g->nos_tracks = freetrks;
	g->tlist = makeArrayTrackList(tracks, nosT);
	g->next_group = NULL;
	addGroup(&root, g);
	free(tracks);
	return root;
}
	
//void addGroup(Tglist *tgl, Groupnode **g){
void addGroup(Groupnode **root, Groupnode *g){
	DBG("%s\n", "Enter addGroup");
	Groupnode *ptr = *root;
	if(*root == NULL){
		DBG("%s\n", "Head is NULL"); 
			*root = g;
	}
	else{
		DBG("%s\n", "Enter else");

	while(ptr->next_group != NULL){
		ptr = ptr->next_group;
	}
	ptr->next_group = g;
	}
}

void addTrack(Tracknode **root, Tracknode *t){
	DBG("%s\n", "Enter addTrack");
	Tracknode *ptr = *root;
	if(*root == NULL){
		DBG("%s\n", "Head is NULL");
			*root = t;
	}
	else{
		DBG("%s\n", "Enter else");
		while(ptr->next_trk != NULL){
			ptr = ptr->next_trk;
		}
	ptr->next_trk = t;
	}
}

Tracknode *makeTrackList(int min, int max){
	DBG("%s\n", "Enter makeTrackList");
	
	Tracknode *root; root = NULL;

	//FIXME: Check
	if(min == 0){
		return root;
	}

	int i = min;
	if(max == 0) max = min;
	while(i <= max){
		DBG("i is: %d\n", i);
		Tracknode *trk = malloc(sizeof(Tracknode));
		trk->next_trk = NULL;
		trk->channels = getTrackEncoding(i-1)[1];
		trk->encoding = getTrackEncoding(i-1)[0];
		trk->gaoled = getTrackFlags(i-1)[0];
		trk->title_ascii = getTrackTitle(i-1, 0);
		trk->title_wchar = NULL; //getTrackTitle(i-1, 1); FIXME: To be tested
		trk->track_no = i;
		trk->length = getTrackLength(i-1);
		trk->r_date = 0; //Probably not implemented on MZ-RH1
		trk->r_time = 0; //Probably not implemented on MZ-RH1
		addTrack(&root, trk);
		i++;
	}
	return root;
}

//FIXME: Merge and split makeTrackList and makeArrayTrackList
Tracknode *makeArrayTrackList(int *tracks, int length){
	DBG("%s\n", "Enter makeArrayTrackList");

	int ii = 0;
  for(ii = 0; ii < length; ii++){
    DBG("MAKEARRAY: TRACK %d is: %d\n", ii, tracks[ii]);
  }	
	Tracknode *root; root = NULL;

	if(length == 0)
		return root;

	int i = 0;
	for(i = 0; i < length; i++){
		if(tracks[i] == 0){
			DBG("i is: %d\n", i);
			Tracknode *trk = malloc(sizeof(Tracknode));
			trk->next_trk = NULL;
			trk->channels = getTrackEncoding(i)[1];
			trk->encoding = getTrackEncoding(i)[0];
			trk->gaoled = getTrackFlags(i)[0];
			trk->title_ascii = getTrackTitle(i, 0);
			trk->title_wchar = NULL; //getTrackTitle(i-1, 1); FIXME: To be tested
			trk->track_no = i + 1;
			trk->length = getTrackLength(i);
			trk->r_date = 0; //Necessary netmd command not known
			trk->r_time = 0; //Necessary netmd command not known
			addTrack(&root, trk);
		}
	}
	return root;
}



//int *getTrackDateTime(int track){
void getTrackDateTime(int track){
  unsigned char *result; //Scanned result - ready for consumption
	unsigned char qq2[] = "0001 0006 0000 %b %b %b %b";

	int rrsize = 0; //Size of reply from _getTrackInfo()

	unsigned char *raw_value;
	raw_value = _getTrackInfo(track, 0x3000, 0x0500, &rrsize);

  result = scanQuery(rrsize, raw_value, qq2);
	dumpResult(result, rrsize);
	
	//int *track_length = malloc(4 * sizeof(int));
	
	//track_length[0] = BCD2int(result[0]);
	//track_length[1] = BCD2int(result[1]);
	//track_length[2] = BCD2int(result[2]);
	//track_length[3] = BCD2int(result[3]);

	//return track_length;
}


/*
FIXME:
void freeTGlist(Groupnode *ptr2){
  Groupnode *ptr;
  for(ptr = ptr2; ptr != NULL; ptr = ptr->next_group){
    for(trk = ptr->tlist; trk != NULL; trk = trk->next_trk){
    }   
  }
}

void freeGroupNode(Groupnode *ptr2){

}

void freeTrackNode(Tracknode *ptr2){
  

}
*/

